{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uatt1
 Author:    od
 Purpose:   Dmonstration du systme d'attente pour le livre Delphi 7
 History:   Mai 2002, V 1.0
-----------------------------------------------------------------------------}



unit uatt1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    btnLancer: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    lSimulation: TLabel;
    Label3: TLabel;
    procedure btnLancerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}
uses uatt2; // systme d'attente

procedure TForm1.btnLancerClick(Sender: TObject);
var i,max:integer;
begin
 max := 200+random(800); // dure alatoire entre 2 et 10s
 OpenWait('Traitement long en cours',true);
 try
   For i := 0 to max do
    begin
     lSimulation.caption := inttostr(i);
     lSimulation.Update;
     SendWait('',Trunc((i/max) * 100.0)); // mise  jour jauge
     Sleep(10); // traitement long simul
    end;
 finally
  CloseWait; // on assure la fermeture mme en cas d'exception
 end;
end;

end.
