{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit udmServer;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, pServeur_TLB, StdVcl, Provider, DB, DBTables;

type
  TTodDemo = class(TRemoteDataModule, ITodDemo)
    Table1: TTable;
    dsDemo: TDataSetProvider;
    Query1: TQuery;
  private
    { Dclarations prives }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
    procedure GetFishCount(MiniSize, MaxiSize: Integer; out Count: OleVariant);
      safecall;
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

class procedure TTodDemo.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TTodDemo.GetFishCount(MiniSize, MaxiSize: Integer;
  out Count: OleVariant);
begin
 Count := 0;
 Query1.ParamByName('mini').AsInteger := MiniSize;
 Query1.ParamByName('maxi').AsInteger := MaxiSize;
 try
  Query1.Open;
  try
   Count := Query1.Fields[0].AsInteger;
  finally
   Query1.close;
  end;
 except
 end;
end;

initialization
  TComponentFactory.Create(ComServer, TTodDemo,
    Class_TodDemo, ciMultiInstance, tmApartment);
end.
