{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: umain
 Author:    O.Dahan
 Purpose:   Dmo des agrgats avec MyBase
 History:   juillet 2002 - v 1.0
-----------------------------------------------------------------------------}



unit umain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls, DBCtrls, Grids, DBGrids, DBClient, StdCtrls;

type
  TForm1 = class(TForm)
    cds1: TClientDataSet;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    cds1PartNo: TFloatField;
    cds1VendorNo: TFloatField;
    cds1Description: TStringField;
    cds1OnHand: TFloatField;
    cds1OnOrder: TFloatField;
    cds1Cost: TCurrencyField;
    cds1ListPrice: TCurrencyField;
    cds1TotalLigneCommande: TCurrencyField;
    DBText1: TDBText;
    DBText2: TDBText;
    cds1SumOnOrder: TAggregateField;
    cds1SumCommandes: TAggregateField;
    Label1: TLabel;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cds1CalcFields(DataSet: TDataSet);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 cds1.Open;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 cds1.Close;
end;

procedure TForm1.cds1CalcFields(DataSet: TDataSet);
begin
 cds1TotalLigneCommande.Value := cds1OnOrder.Value * cds1ListPrice.Value;
end;

end.
