{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{ Invokable interface declaration unit for IODdemo and TODdemo }

unit ODdemoIntf;

interface

uses
  Types, XSBuiltIns, InvokeRegistry,
  sysutils;

type
  { IODdemo }
  IODdemo = interface(IInvokable)
    ['{6C1D6A5F-EDEE-477E-A0C9-0E1D2255F9F2}']
   function getServerDate : string; stdcall;
   function getServerTime : string; stdcall;
   function getFormattedString(const str:string) : string; stdcall;
  end;

  { TODdemo }
  TODdemo = class(TInvokableClass, IODdemo)
   function getServerDate : string; stdcall;
   function getServerTime : string; stdcall;
   function getFormattedString(const str:string) : string; stdcall;
  end;

implementation

{ TODdemo }

function TODdemo.getFormattedString(const str: string): string; stdcall;
begin
 result := Format(str,[GetServerdate,GetServertime]);
end;

function TODdemo.getServerDate: string; stdcall;
begin
 result := DateToStr(Date);
end;

function TODdemo.getServerTime: string; stdcall;
begin
 result := TimeToStr(time);
end;

initialization
  InvRegistry.RegisterInterface(TypeInfo(IODdemo), '', '');
  InvRegistry.RegisterInvokableClass(TODdemo);

end.
