{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// ************************************************************************ //
// Les types dclar dans ce fichier ont t gnrs  partir de donnes lues dans le fichier
// WSDL dcrit ci-dessous :
// WSDL     : http://ws.cdyne.com/emailverify/ev.asmx?wsdl
// Encodage : utf-8
// Version  : 1.0
// (16/06/2002 23:45:16 - $Revision:   1.9.1.0.1.0.1.9  $)
// ************************************************************************ //

unit ev;

interface

uses InvokeRegistry, Types, XSBuiltIns;

type

  // ************************************************************************ //
  // Les types suivants mentionns dans le document WSDL ne sont pas reprsents
  // dans ce fichier. Ce sont soit des alias[@] de types reprsents ou alors ils sont 
  // rfrencs mais jamais[!] dclars dans ce document. Les types de la dernire catgorie
  // sont en principe mapps  des types Borland ou XML prdfinis/connus. Toutefois, ils peuvent aussi
  // signaler des documents WSDL incorrects n'ayant pas russi  dclarer ou importer un type de schma.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"
  // !:int             - "http://www.w3.org/2001/XMLSchema"
  // !:string          - "http://ws.cdyne.com/"

  ReturnIndicator      = class;                 { "http://ws.cdyne.com/" }



  // ************************************************************************ //
  // Espace de nommage : http://ws.cdyne.com/
  // ************************************************************************ //
  ReturnIndicator = class(TRemotable)
  private
    FResponseText: String;
    FResponseCode: Integer;
    FLastMailServer: String;
  published
    property ResponseText: String read FResponseText write FResponseText;
    property ResponseCode: Integer read FResponseCode write FResponseCode;
    property LastMailServer: String read FLastMailServer write FLastMailServer;
  end;

  ArrayOfAnyType = array of String;             { "http://ws.cdyne.com/" }

  // ************************************************************************ //
  // Espace de nommage : http://ws.cdyne.com/
  // soapAction : http://ws.cdyne.com/%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // liaison   : evSoap
  // service   : ev
  // port      : evSoap
  // URL       : http://ws.cdyne.com/emailverify/ev.asmx
  // ************************************************************************ //
  evSoap = interface(IInvokable)
  ['{E58A281A-772F-0DB4-A9FC-8A80F50F450D}']
    function  VerifyEmail(const email: String): ReturnIndicator; stdcall;
    function  ReturnCodes: ArrayOfAnyType; stdcall;
  end;

function GetevSoap(UseWSDL: Boolean=System.False; Addr: string=''): evSoap;


implementation
  uses SOAPHTTPClient;

function GetevSoap(UseWSDL: Boolean; Addr: string): evSoap;
const
  defWSDL = 'http://ws.cdyne.com/emailverify/ev.asmx?wsdl';
  defURL  = 'http://ws.cdyne.com/emailverify/ev.asmx';
  defSvc  = 'ev';
  defPrt  = 'evSoap';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  RIO := THTTPRIO.Create(nil);
  try
     if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
    Result := (RIO as evSoap);
  finally
    if Result = nil then
      RIO.Free;
  end;
end;


initialization
  InvRegistry.RegisterInterface(TypeInfo(evSoap), 'http://ws.cdyne.com/', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(evSoap), 'http://ws.cdyne.com/%operationName%');
  InvRegistry.RegisterInvokeOptions(TypeInfo(evSoap), ioDocument);
  RemClassRegistry.RegisterXSClass(ReturnIndicator, 'http://ws.cdyne.com/', 'ReturnIndicator');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfAnyType), 'http://ws.cdyne.com/', 'ArrayOfAnyType');

end. 