{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure run(cmd:string; txt:TStrings);
var
 PipeIn  :THandle;
 PipeOut :THandle;

 StartupInfo: TStartupInfo;
 ProcessInfo: TProcessInformation;

 Buffer: array[0..4096] of Char;
 NbRead: DWord;
begin
// Crer un pipe d'entres/sorties
 CreatePipe(PipeIn,PipeOut,nil,0);
// Crer le process en redirigeant les E/S
 FillChar(StartupInfo, SizeOf(TStartupInfo),0);
 StartupInfo.cb         :=SizeOf(TStartupInfo);
 StartupInfo.dwFlags    :=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
 StartupInfo.wShowWindow:=SW_HIDE;
 StartupInfo.hStdInput  :=PipeIn;
 StartupInfo.hStdOutput :=PipeOut;
 StartupInfo.hStdError  :=PipeOut;
 CreateProcess(nil,PChar(cmd),nil,nil,True,0,nil,nil,StartupInfo,ProcessInfo);
// attendre la fin du process
 WaitForSingleObject(ProcessInfo.hProcess,INFINITE);
// Fermer la sortie
 CloseHandle(PipeOut);
// pour relire le tout
 while ReadFile(PipeIn,Buffer,4096,NbRead,nil) do txt.Add(Buffer);
// fin
 CloseHandle(PipeIn);
end;
                                               
procedure TForm1.Button1Click(Sender: TObject);
begin
 screen.cursor:=crHourglass;
 run('ping.exe 127.0.0.1',memo1.lines);
 screen.cursor:=crDefault;
 beep;
end;

end.
