{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{$DEFINE STATIC}

{$IFDEF STATIC}
function HowMany:integer; external 'Library1.dll';
function OneMore:integer; external 'Library1.dll';
{$ELSE}
var
 hDLL:integer;
 HowMany:function:integer;
 OneMore:function:integer;
{$ENDIF}

procedure TForm1.FormCreate(Sender: TObject);
begin
{$IFNDEF STATIC}
 hDLL:=LoadLibrary('Library1.dll');
 @HowMany:=GetProcAddress(hDLL,'HowMany');
 @OneMore:=GetProcAddress(hDLL,'OneMore');
{$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
{$IFNDEF STATIC}
 FreeLibrary(hDLL);
{$ENDIF}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 ShowMessage('Nombre =  '+IntToStr(HowMany));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 ShowMessage('Un de plus donne '+IntToStr(OneMore));
end;

end.
