{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Convertisseur2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Euro: TButton;
    Francs: TButton;
    procedure EuroClick(Sender: TObject);
    procedure FrancsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// voir la fiche Conveurtisseur1 pour une liaison statique

var
 Convert     :THandle;
 ConvertEuro :function (Montant:double):double; stdcall;
 ConvertFranc:function (Montant:double):double; stdcall;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Convert:=LoadLibrary('Convert.dll');
 if Convert=0 then raise Exception.Create('La DLL de convertion est introuvable');
 @ConvertEuro:=GetProcAddress(Convert,'ConvertEuro');
 if @ConvertEuro=nil then raise Exception.Create('La fonction ConvertEuro est introuvable');
 @ConvertFranc:=GetProcAddress(Convert,'ConvertFranc');
 if @ConvertFranc=nil then raise Exception.Create('La fonction ConvertFranc est introuvable');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if Convert<>0 then FreeLibrary(Convert);
end;

procedure TForm1.EuroClick(Sender: TObject);
begin
 if @ConvertEuro<>nil then
  Edit1.Text:=FloatToStr(ConvertEuro(StrToFloat(Edit1.Text)));
end;

procedure TForm1.FrancsClick(Sender: TObject);
begin
 if @ConvertFranc<>nil then
  Edit1.Text:=FloatToStr(ConvertFranc(StrToFloat(Edit1.Text)));
end;

end.
