{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit ChatX_TLB;

// ************************************************************************ //
// AVERTISSEMENT                                                                 
// -------                                                                    
// Les types dclars dans ce fichier ont t gnrs  partir de donnes lues 
// depuis la bibliothque de types. Si cette dernire (via une autre bibliothque de types 
// s'y rfrant) est explicitement ou indirectement r-importe, ou la commande "Rafrachir"  
// de l'diteur de bibliothque de types est active lors de la modification de la bibliothque 
// de types, le contenu de ce fichier sera rgnr et toutes les modifications      
// manuellement apportes seront perdues.                                     
// ************************************************************************ //

// PASTLWTR : $Revision:   1.130.1.0.1.0.1.6  $
// Fichier gnr le 11/07/02 22:10:30 depuis la bibliothque de types ci-dessous.

// ************************************************************************  //
// Type Lib: C:\MySoft\Eyrolles\tothpaul\22 - COM DCOM et autres ActiveX\ChatX\ChatX.tlb (1)
// LIBID: {9CC9C480-8F51-11D6-A023-444553540000}
// LCID: 0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\Stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\stdvcl40.dll)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // L'unit doit tre compile sans pointeur  type contrl. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS dclars dans la bibliothque de types. Prfixes utiliss :    
//   Bibliothques de types : LIBID_xxxx                                      
//   CoClasses              : CLASS_xxxx                                      
//   DISPInterfaces         : DIID_xxxx                                       
//   Non-DISP interfaces    : IID_xxxx                                        
// *********************************************************************//
const
  // Versions majeure et mineure de la bibliothque de types
  ChatXMajorVersion = 1;
  ChatXMinorVersion = 0;

  LIBID_ChatX: TGUID = '{9CC9C480-8F51-11D6-A023-444553540000}';

  IID_IActiveChat: TGUID = '{9CC9C481-8F51-11D6-A023-444553540000}';
  DIID_IActiveChatEvents: TGUID = '{9CC9C483-8F51-11D6-A023-444553540000}';
  CLASS_ActiveChat: TGUID = '{9CC9C485-8F51-11D6-A023-444553540000}';

// *********************************************************************//
// Dclaration d'numrations dfinies dans la bibliothque de types    
// *********************************************************************//
// Constantes pour enum TxActiveFormBorderStyle
type
  TxActiveFormBorderStyle = TOleEnum;
const
  afbNone = $00000000;
  afbSingle = $00000001;
  afbSunken = $00000002;
  afbRaised = $00000003;

// Constantes pour enum TxPrintScale
type
  TxPrintScale = TOleEnum;
const
  poNone = $00000000;
  poProportional = $00000001;
  poPrintToFit = $00000002;

// Constantes pour enum TxMouseButton
type
  TxMouseButton = TOleEnum;
const
  mbLeft = $00000000;
  mbRight = $00000001;
  mbMiddle = $00000002;

// Constantes pour enum TxHelpType
type
  TxHelpType = TOleEnum;
const
  htKeyword = $00000000;
  htContext = $00000001;

type

// *********************************************************************//
// Dclaration Forward des types dfinis dans la bibliothque de types    
// *********************************************************************//
  IActiveChat = interface;
  IActiveChatDisp = dispinterface;
  IActiveChatEvents = dispinterface;

// *********************************************************************//
// Dclaration de CoClasses dfinies dans la bibliothque de types 
// (REMARQUE: On affecte chaque CoClasse  son Interface par dfaut)              
// *********************************************************************//
  ActiveChat = IActiveChat;


// *********************************************************************//
// Dclaration de structures, d'unions et d'alias.                        
// *********************************************************************//
  PPUserType1 = ^IFontDisp; {*}


// *********************************************************************//
// Interface   : IActiveChat
// Indicateurs : (4416) Dual OleAutomation Dispatchable
// GUID        : {9CC9C481-8F51-11D6-A023-444553540000}
// *********************************************************************//
  IActiveChat = interface(IDispatch)
    ['{9CC9C481-8F51-11D6-A023-444553540000}']
    function Get_Visible: WordBool; safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function Get_AutoScroll: WordBool; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    function Get_AutoSize: WordBool; safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    function Get_Caption: WideString; safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    function Get_Color: OLE_COLOR; safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    function Get_Font: IFontDisp; safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    function Get_KeyPreview: WordBool; safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    function Get_PixelsPerInch: Integer; safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    function Get_Scaled: WordBool; safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    function Get_Active: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    function Get_HelpFile: WideString; safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    function Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    function Get_Cursor: Smallint; safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    function Get_HelpType: TxHelpType; safecall;
    procedure Set_HelpType(Value: TxHelpType); safecall;
    function Get_HelpKeyword: WideString; safecall;
    procedure Set_HelpKeyword(const Value: WideString); safecall;
    procedure AddLine(const Text: WideString; Color: Integer); safecall;
    function Get_LineCount: Integer; safecall;
    function Get_Lines(Index: Integer): WideString; safecall;
    procedure Set_Lines(Index: Integer; const Value: WideString); safecall;
    function Get_Text: WideString; safecall;
    procedure Set_Text(const Value: WideString); safecall;
    property Visible: WordBool read Get_Visible write Set_Visible;
    property AutoScroll: WordBool read Get_AutoScroll write Set_AutoScroll;
    property AutoSize: WordBool read Get_AutoSize write Set_AutoSize;
    property AxBorderStyle: TxActiveFormBorderStyle read Get_AxBorderStyle write Set_AxBorderStyle;
    property Caption: WideString read Get_Caption write Set_Caption;
    property Color: OLE_COLOR read Get_Color write Set_Color;
    property Font: IFontDisp read Get_Font write Set_Font;
    property KeyPreview: WordBool read Get_KeyPreview write Set_KeyPreview;
    property PixelsPerInch: Integer read Get_PixelsPerInch write Set_PixelsPerInch;
    property PrintScale: TxPrintScale read Get_PrintScale write Set_PrintScale;
    property Scaled: WordBool read Get_Scaled write Set_Scaled;
    property Active: WordBool read Get_Active;
    property DropTarget: WordBool read Get_DropTarget write Set_DropTarget;
    property HelpFile: WideString read Get_HelpFile write Set_HelpFile;
    property DoubleBuffered: WordBool read Get_DoubleBuffered write Set_DoubleBuffered;
    property AlignDisabled: WordBool read Get_AlignDisabled;
    property VisibleDockClientCount: Integer read Get_VisibleDockClientCount;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
    property Cursor: Smallint read Get_Cursor write Set_Cursor;
    property HelpType: TxHelpType read Get_HelpType write Set_HelpType;
    property HelpKeyword: WideString read Get_HelpKeyword write Set_HelpKeyword;
    property LineCount: Integer read Get_LineCount;
    property Lines[Index: Integer]: WideString read Get_Lines write Set_Lines;
    property Text: WideString read Get_Text write Set_Text;
  end;

// *********************************************************************//
// DispIntf :  IActiveChatDisp
// Flags :     (4416) Dual OleAutomation Dispatchable
// GUID :      {9CC9C481-8F51-11D6-A023-444553540000}
// *********************************************************************//
  IActiveChatDisp = dispinterface
    ['{9CC9C481-8F51-11D6-A023-444553540000}']
    property Visible: WordBool dispid 1;
    property AutoScroll: WordBool dispid 2;
    property AutoSize: WordBool dispid 3;
    property AxBorderStyle: TxActiveFormBorderStyle dispid 4;
    property Caption: WideString dispid -518;
    property Color: OLE_COLOR dispid -501;
    property Font: IFontDisp dispid -512;
    property KeyPreview: WordBool dispid 5;
    property PixelsPerInch: Integer dispid 6;
    property PrintScale: TxPrintScale dispid 7;
    property Scaled: WordBool dispid 8;
    property Active: WordBool readonly dispid 9;
    property DropTarget: WordBool dispid 10;
    property HelpFile: WideString dispid 11;
    property DoubleBuffered: WordBool dispid 12;
    property AlignDisabled: WordBool readonly dispid 13;
    property VisibleDockClientCount: Integer readonly dispid 14;
    property Enabled: WordBool dispid -514;
    property Cursor: Smallint dispid 15;
    property HelpType: TxHelpType dispid 16;
    property HelpKeyword: WideString dispid 17;
    procedure AddLine(const Text: WideString; Color: Integer); dispid 18;
    property LineCount: Integer readonly dispid 21;
    property Lines[Index: Integer]: WideString dispid 22;
    property Text: WideString dispid 23;
  end;

// *********************************************************************//
// DispIntf :  IActiveChatEvents
// Flags :     (4096) Dispatchable
// GUID :      {9CC9C483-8F51-11D6-A023-444553540000}
// *********************************************************************//
  IActiveChatEvents = dispinterface
    ['{9CC9C483-8F51-11D6-A023-444553540000}']
    procedure OnActivate; dispid 1;
    procedure OnClick; dispid 2;
    procedure OnCreate; dispid 3;
    procedure OnDblClick; dispid 5;
    procedure OnDestroy; dispid 6;
    procedure OnDeactivate; dispid 7;
    procedure OnKeyPress(var Key: Smallint); dispid 11;
    procedure OnPaint; dispid 16;
  end;


// *********************************************************************//
// Dclaration de classe proxy de contrle OLE
// Nom du contrle      : TActiveChat
// Chane d'aide        : ActiveChat Contrle
// Interface par dfaut : IActiveChat
// DISP Int. Df. ?     : No
// Interface vnements : IActiveChatEvents
// TypeFlags            : (34) CanCreate Control
// *********************************************************************//
  TActiveChatOnKeyPress = procedure(Sender: TObject; var Key: Smallint) of object;

  TActiveChat = class(TOleControl)
  private
    FOnActivate: TNotifyEvent;
    FOnClick: TNotifyEvent;
    FOnCreate: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnDestroy: TNotifyEvent;
    FOnDeactivate: TNotifyEvent;
    FOnKeyPress: TActiveChatOnKeyPress;
    FOnPaint: TNotifyEvent;
    FIntf: IActiveChat;
    function  GetControlInterface: IActiveChat;
  protected
    procedure CreateControl;
    procedure InitControlData; override;
    function Get_Lines(Index: Integer): WideString;
    procedure Set_Lines(Index: Integer; const Value: WideString);
  public
    procedure AddLine(const Text: WideString; Color: Integer);
    property  ControlInterface: IActiveChat read GetControlInterface;
    property  DefaultInterface: IActiveChat read GetControlInterface;
    property Visible: WordBool index 1 read GetWordBoolProp write SetWordBoolProp;
    property Active: WordBool index 9 read GetWordBoolProp;
    property DropTarget: WordBool index 10 read GetWordBoolProp write SetWordBoolProp;
    property HelpFile: WideString index 11 read GetWideStringProp write SetWideStringProp;
    property DoubleBuffered: WordBool index 12 read GetWordBoolProp write SetWordBoolProp;
    property AlignDisabled: WordBool index 13 read GetWordBoolProp;
    property VisibleDockClientCount: Integer index 14 read GetIntegerProp;
    property Enabled: WordBool index -514 read GetWordBoolProp write SetWordBoolProp;
    property LineCount: Integer index 21 read GetIntegerProp;
    property Lines[Index: Integer]: WideString read Get_Lines write Set_Lines;
  published
    property  ParentColor;
    property  ParentFont;
    property  Align;
    property  DragCursor;
    property  DragMode;
    property  ParentShowHint;
    property  PopupMenu;
    property  ShowHint;
    property  TabOrder;
    property  OnDragDrop;
    property  OnDragOver;
    property  OnEndDrag;
    property  OnEnter;
    property  OnExit;
    property  OnStartDrag;
    property AutoScroll: WordBool index 2 read GetWordBoolProp write SetWordBoolProp stored False;
    property AutoSize: WordBool index 3 read GetWordBoolProp write SetWordBoolProp stored False;
    property AxBorderStyle: TOleEnum index 4 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property Caption: WideString index -518 read GetWideStringProp write SetWideStringProp stored False;
    property Color: TColor index -501 read GetTColorProp write SetTColorProp stored False;
    property Font: TFont index -512 read GetTFontProp write SetTFontProp stored False;
    property KeyPreview: WordBool index 5 read GetWordBoolProp write SetWordBoolProp stored False;
    property PixelsPerInch: Integer index 6 read GetIntegerProp write SetIntegerProp stored False;
    property PrintScale: TOleEnum index 7 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property Scaled: WordBool index 8 read GetWordBoolProp write SetWordBoolProp stored False;
    property Cursor: Smallint index 15 read GetSmallintProp write SetSmallintProp stored False;
    property HelpType: TOleEnum index 16 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property HelpKeyword: WideString index 17 read GetWideStringProp write SetWideStringProp stored False;
    property Text: WideString index 23 read GetWideStringProp write SetWideStringProp stored False;
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnCreate: TNotifyEvent read FOnCreate write FOnCreate;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnDestroy: TNotifyEvent read FOnDestroy write FOnDestroy;
    property OnDeactivate: TNotifyEvent read FOnDeactivate write FOnDeactivate;
    property OnKeyPress: TActiveChatOnKeyPress read FOnKeyPress write FOnKeyPress;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
  end;

procedure Register;

resourcestring
  dtlServerPage = 'Servers';

implementation

uses ComObj;

procedure TActiveChat.InitControlData;
const
  CEventDispIDs: array [0..7] of DWORD = (
    $00000001, $00000002, $00000003, $00000005, $00000006, $00000007,
    $0000000B, $00000010);
  CTFontIDs: array [0..0] of DWORD = (
    $FFFFFE00);
  CControlData: TControlData2 = (
    ClassID: '{9CC9C485-8F51-11D6-A023-444553540000}';
    EventIID: '{9CC9C483-8F51-11D6-A023-444553540000}';
    EventCount: 8;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: nil (*HR:$00000000*);
    Flags: $0000001D;
    Version: 401;
    FontCount: 1;
    FontIDs: @CTFontIDs);
begin
  ControlData := @CControlData;
  TControlData2(CControlData).FirstEventOfs := Cardinal(@@FOnActivate) - Cardinal(Self);
end;

procedure TActiveChat.CreateControl;

  procedure DoCreate;
  begin
    FIntf := IUnknown(OleObject) as IActiveChat;
  end;

begin
  if FIntf = nil then DoCreate;
end;

function TActiveChat.GetControlInterface: IActiveChat;
begin
  CreateControl;
  Result := FIntf;
end;

function TActiveChat.Get_Lines(Index: Integer): WideString;
begin
    Result := DefaultInterface.Lines[Index];
end;

procedure TActiveChat.Set_Lines(Index: Integer; const Value: WideString);
  { Avertissement : la proprit Lines possde un Setter et un Getter dont les
  types ne correspondent pas. Delphi n'a pas pu gnrer une proprit de
  cette sorte et utilise par consquent un Variant pour dfinir la proprit. }
var
  InterfaceVariant: OleVariant;
begin
  InterfaceVariant := DefaultInterface;
  InterfaceVariant.Lines := Value;
end;

procedure TActiveChat.AddLine(const Text: WideString; Color: Integer);
begin
  DefaultInterface.AddLine(Text, Color);
end;

procedure Register;
begin
  RegisterComponents('ActiveX',[TActiveChat]);
end;

end.
