{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uInfos
 Author:    od
 Purpose:   dmo de la design pattern "observer"
            fiche d'infos example
 History:
-----------------------------------------------------------------------------}



unit uInfos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uobserver;

type
  TForm3 = class(TForm)
    Label1: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
  public
    // rfrence de l'observer pour dsenregistrement
    Observer : TObservedStock;
    // procdure d'observation enregistre auprs de l'objet observe
    Procedure Observe(Observed:TObservedStock;Event:TObservationType);
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

Procedure Tform3.Observe(Observed:TObservedStock;Event:TObservationType);
begin
 // mise  jour affichage
 Label7.Caption := formatfloat('#,##0',observed.Stock);
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree; // libration de la form sur fermeture
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
 Observer.UnregisterObserver(observe); // dsenregistrement
end;

end.
