{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{-$define USE_API}

{$ifdef USE_API}
function ReadIniString(Section,Key,Default,IniName:pchar):string;
 var
  b:array[0..80] of char;
  i:integer;
 begin
  i:=GetPrivateProfileString(Section,Key,Default,b,80,IniName);
  Result:=Copy(b,1,i);
 end;
{$else}
uses
 IniFiles;
{$endif}

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
{$ifdef USE_API}
var
 s:string;
{$endif}
begin
{$ifdef USE_API}
 s:=ChangeFileExt(Application.ExeName,'.INI');
 Caption:='dernire utilisation le '
         +ReadIniString('Time','Date',pchar(DateTimeToStr(Now)),pchar(s));
{$else}
// Lecture de la date de dernire utilisation de l'application
 with TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI')) do begin
  Caption:='dernire utilisation le '
          +DateTimeToStr(ReadDateTime('Time','Date',Now));
  Free;
 end;
{$endif}
end;

procedure TForm1.FormDestroy(Sender: TObject);
{$ifdef USE_API}
var
 s:string;
{$endif}
begin
{$ifdef USE_API}
 s:=ChangeFileExt(Application.ExeName,'.INI');
 WritePrivateProfileString('Time','Date',pchar(DateTimeToStr(Now)),pchar(s));
{$else}
// Mise  jour de la date de dernire utilisation de l'application
 with TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI')) do begin
  WriteDateTime('Time','Date',Now);
  Free;
 end;
{$endif}
end;

end.
