{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// ************************************************************************ //
// Les types dclar dans ce fichier ont t gnrs  partir de donnes lues dans le fichier
// WSDL dcrit ci-dessous :
// WSDL     : http://www.xmethods.net/sd/2001/BabelFishService.wsdl
// Version  : 1.0
// (17/06/2002 00:47:12 - $Revision:   1.9.1.0.1.0.1.9  $)
// ************************************************************************ //

unit BabelFishService;

interface

uses InvokeRegistry, Types, XSBuiltIns;

type

  // ************************************************************************ //
  // Les types suivants mentionns dans le document WSDL ne sont pas reprsents
  // dans ce fichier. Ce sont soit des alias[@] de types reprsents ou alors ils sont 
  // rfrencs mais jamais[!] dclars dans ce document. Les types de la dernire catgorie
  // sont en principe mapps  des types Borland ou XML prdfinis/connus. Toutefois, ils peuvent aussi
  // signaler des documents WSDL incorrects n'ayant pas russi  dclarer ou importer un type de schma.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"


  // ************************************************************************ //
  // Espace de nommage : urn:xmethodsBabelFish
  // soapAction : urn:xmethodsBabelFish#BabelFish
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : rpc
  // liaison   : BabelFishBinding
  // service   : BabelFishService
  // port      : BabelFishPort
  // URL       : http://services.xmethods.net:80/perl/soaplite.cgi
  // ************************************************************************ //
  BabelFishPortType = interface(IInvokable)
  ['{B04F2684-B029-834D-8A91-8366E7B7E356}']
    function  BabelFish(const translationmode: String; const sourcedata: String): String; stdcall;
  end;

function GetBabelFishPortType(UseWSDL: Boolean=System.False; Addr: string=''): BabelFishPortType;


implementation
  uses SOAPHTTPClient;

function GetBabelFishPortType(UseWSDL: Boolean; Addr: string): BabelFishPortType;
const
  defWSDL = 'http://www.xmethods.net/sd/2001/BabelFishService.wsdl';
  defURL  = 'http://services.xmethods.net:80/perl/soaplite.cgi';
  defSvc  = 'BabelFishService';
  defPrt  = 'BabelFishPort';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  RIO := THTTPRIO.Create(nil);
  try
     if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
    Result := (RIO as BabelFishPortType);
  finally
    if Result = nil then
      RIO.Free;
  end;
end;


initialization
  InvRegistry.RegisterInterface(TypeInfo(BabelFishPortType), 'urn:xmethodsBabelFish', '');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(BabelFishPortType), 'urn:xmethodsBabelFish#BabelFish');

end. 