{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// ************************************************************************ //
// Les types dclar dans ce fichier ont t gnrs  partir de donnes lues dans le fichier
// WSDL dcrit ci-dessous :
// WSDL     : http://localhost/scripts/oddemo.exe/wsdl/IODDemo
// Version  : 1.0
// (18/06/2002 04:20:30 - $Revision:   1.9.1.0.1.0.1.9  $)
// ************************************************************************ //

unit IODDemo1;

interface

uses InvokeRegistry, Types, XSBuiltIns;

type

  // ************************************************************************ //
  // Les types suivants mentionns dans le document WSDL ne sont pas reprsents
  // dans ce fichier. Ce sont soit des alias[@] de types reprsents ou alors ils sont 
  // rfrencs mais jamais[!] dclars dans ce document. Les types de la dernire catgorie
  // sont en principe mapps  des types Borland ou XML prdfinis/connus. Toutefois, ils peuvent aussi
  // signaler des documents WSDL incorrects n'ayant pas russi  dclarer ou importer un type de schma.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"


  // ************************************************************************ //
  // Espace de nommage : urn:ODdemoIntf-IODdemo
  // soapAction : urn:ODdemoIntf-IODdemo#%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : rpc
  // liaison   : IODdemobinding
  // service   : IODdemoservice
  // port      : IODDemoPort
  // URL       : http:///wsdl/IODDemo/soap/IODDemo
  // ************************************************************************ //
  IODdemo = interface(IInvokable)
  ['{6F28BED6-550C-F3D4-2D7E-AD63AB053DA9}']
    function  getServerDate: String; stdcall;
    function  getServerTime: String; stdcall;
    function  getFormattedString(const str: String): String; stdcall;
  end;

function GetIODdemo(UseWSDL: Boolean=System.False; Addr: string=''): IODdemo;


implementation
  uses SOAPHTTPClient;

function GetIODdemo(UseWSDL: Boolean; Addr: string): IODdemo;
const
  defWSDL = 'http://localhost/scripts/oddemo.exe/wsdl/IODDemo';
  defURL  = '/wsdl/IODDemo/soap/IODDemo';
  defSvc  = 'IODdemoservice';
  defPrt  = 'IODDemoPort';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  RIO := THTTPRIO.Create(nil);
  try
     if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
    Result := (RIO as IODdemo);
  finally
    if Result = nil then
      RIO.Free;
  end;
end;


initialization
  InvRegistry.RegisterInterface(TypeInfo(IODdemo), 'urn:ODdemoIntf-IODdemo', '');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(IODdemo), '');

end.