{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ToutFermer: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToutFermerClick(Sender: TObject);
  private
    { Dclarations prives }
    Sem  :THandle;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 ShellAPI;

var
 Event:THandle;

function CloseAll(HWnd:THandle):integer; stdcall;
 begin
 // attente de l'vnement
  WaitForSingleObject(Event,INFINITE);
 // et indiquer  l'application qu'elle doit se fermer
  PostMessage(HWnd,WM_QUIT,0,0);
  Result:=0;
 end;

procedure TForm1.FormCreate(Sender: TObject);
var
 count:integer;
 max:integer;
 id:cardinal;
begin
// smaphore de positionnement
 Sem:=CreateSemaphore(nil,0,9,'Event.Demo.Semaphore.Delphi7');
// "lecture" du smaphore
 if ReleaseSemaphore(Sem,1,@count) then begin
 // nombre maximum de fentre sur la largeur de l'cran
  max:=(Screen.Width div Width);
 // positionner cet instance de l'application
  Left:=Width*(count mod max);
  Top:=Height*(count div max);
 // numroter le titre
  Caption:=Caption+'['+IntToStr(Count)+']';
 // lancer une nouvelle instance
  ShellExecute(0,nil,pchar(Application.ExeName),nil,nil,SW_SHOW);
 end;
// dclaration de l'vnement qui mettre fin  l'application
 Event:=CreateEvent(nil,True,False,'Event.Demo.Delphi7');
// mise en attente de l'vnement dans un thread
 if Event<>0 then CreateThread(nil,0,@CloseAll,pointer(Handle),0,id);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CloseHandle(Sem);
 CloseHandle(Event);
end;

procedure TForm1.ToutFermerClick(Sender: TObject);
begin
 SetEvent(Event);
end;

end.
