{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Prendre: TButton;
    Rendre: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PrendreClick(Sender: TObject);
    procedure RendreClick(Sender: TObject);
  private
    { Dclarations prives }
    Sem:THandle;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 Sem:=CreateSemaphore(nil,5,10,'Sem.Demo.Delphi7');
 if Sem=0 then begin
  ShowMessage('Erreur d''ouverture du Semaphore');
 end else begin
  if GetLastError=ERROR_ALREADY_EXISTS then begin
   ShowMessage('on est pas le premier');
  end else begin
   ShowMessage('Le Semaphore est en place (5/10)');
  end;
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CloseHandle(Sem);
end;

procedure TForm1.PrendreClick(Sender: TObject);
begin
 WaitForSingleObject(Sem,INFINITE);
 Beep;
end;

procedure TForm1.RendreClick(Sender: TObject);
var
 Count:integer;
begin
 if ReleaseSemaphore(Sem,1,@Count) then
  ShowMessage(IntTostr(Count+1)+' accs sur 10 possibles')
 else
  ShowMessage('Rien  librer');
end;

end.
 