{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

library IPlugin1;

uses
 Windows,Classes,Dialogs,Menus,
 IPlugins;

{$R bitmap1.res}

Type
 TIPlugin=class(TInterfacedObject,IPlugin)
 private
  fCaption :string;
  fShortCut:TShortCut;
  fBitmap  :THandle;
 public
  Constructor Create(ACaption:string; AShortCut:TShortCut; ABitmap:THandle);
  Destructor Destroy; override;
 // interface IPlugin
  procedure DoClick; stdcall;
  function Caption:pchar; stdcall;
  function ShortCut:TShortCut; stdcall;
  function Bitmap:THandle; stdcall;
 end;

Constructor TIPlugin.Create(ACaption:string; AShortCut:TShortCut; ABitmap:THandle);
 begin
  inherited Create;
  fCaption:=ACaption;
  fShortCut:=AShortCut;
  fBitmap:=ABitmap;
 end;

Destructor TIPlugin.Destroy;
 begin
  ShowMessage('bye !');
  inherited;
 end;

procedure TIPlugin.DoClick;
 begin
  ShowMessage('Clicked on '+fCaption);
 end;

function TIPlugin.Caption:pchar;
 begin
  Result:=PChar(fCaption);
 end;                                         

function TIPlugin.ShortCut:TShortCut;
 begin
  Result:=fShortCut;
 end;

function TIPlugin.Bitmap:THandle;
 begin
  Result:=fBitmap;
 end;

function CreatePlugin:IPlugin; stdcall;
 begin
  Result:=TIPlugin.Create('IPlugin 1',TextToShortCut('Ctrl+1'),LoadBitmap(hInstance,'PLUGIN'));
 end;

exports
 CreatePlugin;

begin
end.
