{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit QURLLabel;

interface

uses
  Windows, Messages, SysUtils, Classes,
  QControls, QStdCtrls,
  QGraphics,ShellAPI;

type
  TQURLLabel = class(TLabel)
  protected
   procedure Click; override;
  public
   Constructor Create(AOwner:TComponent); override;
  published
   property Cursor default crHandPoint;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('LivreD7', [TQURLLabel]);
end;

Constructor TQURLLabel.Create(AOwner:TComponent);
 begin
  inherited;
  Font.Color:=clBlue;
  Font.Style:=[fsUnderline];
  Cursor:=crHandPoint;
 end;

procedure TQURLLabel.Click;
 var
  s:string;
 begin
  if Hint='' then
   inherited
  else
   s:=Hint;
   ShellExecute(0,nil,pchar(Hint),nil,nil,0);
 end;

end.
