{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uNewClass
 Author:    od
 Purpose:   DP "adapter"
            Dfinition de la nouvelle classe qui sera utilise dans
            les applications  venir
 History:   mai 2002 - v1.0
-----------------------------------------------------------------------------}

unit uNewClass;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
// la nouvelle classe utilise String au lieu de String[30]
// et double au lieu de integer pour ses proprits
// De plus elle expose des proprits au lieu des fonctions

 TNewClass = Class
  private
   // anciens champs avec nouveaux types
   FChampTexte : string;
   FChampNum   : Double;
   // nouveau champ
   FNouveauChamp : char;
  protected
   // les accesseurs dclars en virtuel
   procedure SetTexte(s:string); virtual;
   function  GetTexte : string; virtual;
   procedure SetNum(v:double); virtual;
   function  GetNum:double; virtual;
   procedure SetChar(c:char); virtual;
   function  GetChar:char; virtual;
  public
   function NouvelleMethode : string; virtual;
   // proprits anciennes et nouvelles
   property Texte : string read GetTexte write SetTexte;
   property Num   : double read GetNum   write SetNum;
   property Char  : char   read GetChar  write SetChar;   
  end;

implementation

procedure TNewClass.SetTexte(s:string);
begin
 FChampTexte:=s;
end;

function  TNewClass.GetTexte : string;
begin
 result := FChampTexte;
end;

procedure TNewClass.SetNum(v:double);
begin
 FChampNum := v;
end;

function  TNewClass.GetNum:double;
begin
 result := FChampNum;
end;

procedure TNewClass.Setchar(c:char);
begin
 FNouveauChamp := c;
end;

function  TNewClass.GetChar:char;
begin
 result := FNouveauChamp;
end;

function TNewClass.NouvelleMethode : string;
begin
 result := '['+self.char+']'+floattostr(Num)+Texte;
end;

end.
