{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit DemoComp;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TDemoComp = class (TComponent)
  private
    FFichier: string;
    procedure SetFichier(Value: string);
  protected
    constructor CreateInstance;
    class function AccessInstance(Request: Integer): TDemoComp;
  public
    constructor Create;
    destructor Destroy; override;
    class function Instance: TDemoComp;
    class procedure ReleaseInstance;
    property Fichier: string read FFichier write SetFichier;
  end;


procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('Samples', [TDemoComp]);
end;

{
********************************** TDemoComp ***********************************
}
constructor TDemoComp.Create;
begin

  raise Exception.CreateFmt('Accdez  la classe %s par CreateInstance seulement.',
          [ClassName]);
end;

constructor TDemoComp.CreateInstance;
begin
  inherited Create(nil);
end;

destructor TDemoComp.Destroy;
begin
  if AccessInstance(0) = Self then AccessInstance(2);
  inherited Destroy;
end;

class function TDemoComp.AccessInstance(Request: Integer): TDemoComp;

  Const FInstance: TDemoComp = nil;

begin
  case Request of
    0 : ;
    1 : if not Assigned(FInstance) then FInstance := CreateInstance;
    2 : FInstance := nil;
  else
    raise Exception.CreateFmt('Illegal request %d in AccessInstance',
            [Request]);
  end;
  Result := FInstance;
end;

class function TDemoComp.Instance: TDemoComp;
begin
  Result := AccessInstance(1);
end;

class procedure TDemoComp.ReleaseInstance;
begin
  AccessInstance(0).Free;
end;

procedure TDemoComp.SetFichier(Value: string);
begin
  if FFichier <> Value then
  begin
    FFichier := Value;
  end;
end;


end.
