{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Button2: TButton;
    Bevel1: TBevel;
    Label2: TLabel;
    Bevel2: TBevel;
    Button3: TButton;
    Label3: TLabel;
    Button4: TButton;
    Edit2: TEdit;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses usingleton, uSingletonVrai;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 edit1.text := IntToStr(LeSingleton.getchamp);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 LeSingleton.SetChamp(StrToIntDef(edit1.Text,0));
end;

procedure TForm1.Button3Click(Sender: TObject);
var dummy:tsingleton;
begin
 // la mthode A n'interdit pas l'action suivante ..
 // l'instance sera perdue, non dtruite elle va
 // enconmbrer la mmoire voire pire...
 dummy := tsingleton.Create;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 edit2.text := DateTimeToStr(TSingletonvrai.instance.UneMethode);
end;

procedure TForm1.Button5Click(Sender: TObject);
var dummy : tSingletonVrai;
begin
 // le vrai singleton va refuser l'ordre suivant
 dummy := TSingletonVrai.Create;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 edit2.text := DateTimeToStr(LeSingletonVrai.UneMethode);
end;

end.
